// BkDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "BkDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CAboutDlg dialog used for App About
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CBkDlg dialog
CBkDlg::CBkDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBkDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBkDlg)
	m_s1 = _T("");
	m_fU = 0.0f;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBkDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBkDlg)
	DDX_Control(pDX, IDDLL, m_btnDll);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDLIRE, m_btnLire);
	DDX_Text(pDX, IDC_STATIC1, m_s1);
	DDX_Text(pDX, IDC_U, m_fU);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBkDlg, CDialog)
	//{{AFX_MSG_MAP(CBkDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDLIRE, OnLire)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDDLL, OnDll)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CBkDlg message handlers

BOOL CBkDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_s1="";
	//La zone de texte ne sert qu' l'affichage...
	GetDlgItem(IDC_U)->EnableWindow(FALSE);
	m_hDLL=LoadLibrary("EurosmartDX.dll");
	short nb=0;
	m_OK1=FALSE;
	if (m_hDLL!=NULL)
	{
		m_ok=TRUE;
		LitTension=(float(*)(int,char,int))GetProcAddress(m_hDLL,"LitTension");
		if (LitTension==NULL)
		{ 
			m_ok=FALSE;nb++;
		}
		Sort_U=(void(*)(char,float))GetProcAddress(m_hDLL,"Sort_U");
		if (Sort_U==NULL)
		{ 
			m_ok=FALSE;nb++;
		}
		OKCarte=(BOOL(*)(void))GetProcAddress(m_hDLL,"OKCarte");
		if (OKCarte==NULL)
		{ 
			m_ok=FALSE;nb++;
		}
		Connect=(BOOL(*)(void))GetProcAddress(m_hDLL,"Connect");
		if (Connect==NULL)
		{ 
			m_ok=FALSE;nb++;
		}
		AppelDX=(BOOL(*)(void))GetProcAddress(m_hDLL,"AppelDX");
		if (AppelDX==NULL)
		{ 
			m_ok=FALSE;nb++;
		}
		LibereDX=(BOOL(*)(void))GetProcAddress(m_hDLL,"LibereDX");
		if (LibereDX==NULL)
		{ 
			m_ok=FALSE;nb++;
		}
		if (!m_ok)
		{
			m_s1.Format("%d fonction(s) non trouve(s) dans EurosmartDX.dll !",nb);
			m_btnLire.EnableWindow(FALSE);
		}
	}
	else
	{
		m_s1.Format("Librairie EurosmartDX.dll non trouve !");
		m_ok=FALSE;
		m_btnLire.EnableWindow(FALSE);
	}

	if (m_ok)
	{
		if (AppelDX()==TRUE)
		{
			m_OK1=TRUE;
			if (OKCarte()==FALSE)
			{
				m_s1.Format("Carte Eurosmart PC-MES3 non trouve !\n(OKCarte=%d)",OKCarte());
				m_btnLire.EnableWindow(FALSE);
			}
			else
			{
				m_s1.Format("Carte Eurosmart PC-MES3 OK...\n(OKCarte=%d)",OKCarte());
			}
		}
		else
		{
			m_btnLire.EnableWindow(FALSE);
			m_s1.Format("Erreur logiciel DriverX !\nDevice: eurosmart - Bus Type: ISA - Uses port range\nPort Base: 0X330 - Port Count: 0X12 - Ignore ressource conflicts");
		}
	}
	m_OK=FALSE;
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CBkDlg::OnLire() 
{
	if (m_OK==FALSE)
	{
		//Lire
		m_btnLire.SetWindowText("&Arrter");
		m_btnCancel.EnableWindow(FALSE);
		m_btnDll.EnableWindow(FALSE);
		m_iNb=0;
		m_OKBusy=FALSE;SetTimer(1,50,NULL);
	}
	else
	{
		//Arrter
		KillTimer(1);
		m_btnLire.SetWindowText("&Lire");
		m_btnCancel.EnableWindow(TRUE);
		m_btnDll.EnableWindow(TRUE);
		m_s1.Format("Arrt conversion A/N demande...");
		UpdateData(FALSE);	
	}
	m_OK=!m_OK;
}
//________________________________________
void CBkDlg::OnTimer(UINT nIDEvent) 
{
	BYTE Voie=0;//N de voie A/N, 0  7
	if (m_OKBusy==FALSE)
	{
		m_OKBusy=TRUE;
		m_fU=LitTension(Voie,1,10);//0:uni, 1:bipolaire, 10:moyenne
		m_iNb++;
		m_s1.Format("Conversion A/N bipolaire en cours... (%d)",m_iNb);
		UpdateData(FALSE);	
		m_OKBusy=FALSE;
	}
	CDialog::OnTimer(nIDEvent);
}
//________________________________________
void CBkDlg::OnCancel() 
{
	BOOL ok;
	if (m_OK1) LibereDX();
	if (m_hDLL!=NULL)
	{
		ok=FreeLibrary(m_hDLL);
		//if (ok) AfxMessageBox("EurosmartDX.dll libr...");
	}
	CDialog::OnCancel();
}
//________________________________________
void CBkDlg::OnDll() 
{
	AfxMessageBox("PROTOTYPES des fonctions de EurosmartDX.dll\n\nBOOL AppelDX(void);\nvoid LibereDX(void);\nBOOL Connect(void);\n\nBOOL OKCarte(void);\nfloat LitTension(int NoVoie,char Type,int Nb);\nvoid Sort_U(char NoVoie,float U);");	
}
//________________________________________
void CBkDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}
//________________________________________
// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.
//________________________________________
void CBkDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}
//________________________________________
// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBkDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
